<template>
  <div
    v-if="isVisibleAdvance"
    class="order-advance-button-wrapper"
  >
    <div
      class="order-advance-button"
      :class="[
        isCancelled && '--danger',
        !isCancelled && '--clickable',
      ]"
      @click="!isCancelled && setVisibleAdvance(true)"
    >
      <div class="order-advance-button__status">
        <span v-html="infoByStatus.icon" />
        <div class="title">
          <div class="title__main">{{ infoByStatus.title }}</div>
          <div
            v-if="currentStatus === 'FULLY_PAID'"
            class="title__second"
          >
            Получен {{ currentAdvanceInfo.paidAt | date('DD.MM.YYYY') }}
          </div>
        </div>
      </div>
      <div
        v-if="currentStatus !== 'CANCELLED'"
        class="order-advance-button__price"
      >
        <span>{{ order.advanceAvailable / 100 | currency({ dot: 2 }) }} ₽</span>
        <i class="icon chevron-right" />
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapMutations } from 'vuex'
import { infoByStatus } from '@/components/Order/orderItem/advance/constants'

export default {
  name: 'OrderAdvanceButton',
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  computed: {
    ...mapGetters({
      advanceInfo: 'order/advanceInfo',
      isCarrier: 'user/isCarrier'
    }),
    currentAdvanceInfo () {
      return this.advanceInfo[this.order.uuid] || {}
    },
    currentStatus () {
      return this.currentAdvanceInfo.status
    },
    isCancelled () {
      return this.currentStatus === 'CANCELLED'
    },
    infoByStatus () {
      return infoByStatus(this.currentStatus === null ? 'DEFAULT' : this.currentStatus)
    },
    isVisibleAdvance () {
      return Object.keys(this.currentAdvanceInfo).length && this.isCarrier && this.order.species === 'AUTO' && ((!this.currentStatus && ['CONTRACTED', 'IN_PROCESS', 'PROCESSED'].includes(this.order.status)) || this.currentStatus)
    }
  },
  methods: {
    ...mapMutations({
      setVisibleAdvance: 'order/setVisibleAdvance'
    })
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-advance-button {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    @include font-mixin(14px, 18px, 700);
    color: $green-800;
    &-wrapper {
      margin-top: 24px;
      padding-top: 21px;
      border-top: 1px solid $color-grey-border;
    }
    &.--clickable {
      cursor: pointer;
      &:hover {
        opacity: 0.8;
      }
    }
    &.--danger {
      color: $light-raspberry-red;
    }
    &__status {
      display: flex;
      justify-content: flex-start;
      &::v-deep {
        .icon, svg {
          margin-right: 8px;
        }
      }
      .title {
        &__main {
          margin-top: 3px;
        }
        &__second {
          margin-top: 6px;
          @include font-mixin(12px, 14px, 400, 0.4px);
        }
      }
    }
    &__price {
      display: flex;
      justify-content: flex-end;
      align-items: center;
      margin-top: 3px;
      span {}
      .icon {
        margin-left: 10px;
      }
    }
  }
</style>
